﻿using System;
using System.Net.Sockets ;
using System.IO ;
using System.Collections;
using System.Runtime.Serialization; 
using System.Runtime.Serialization.Formatters.Binary; 
using System.Text;
using System.Threading;
//using System.Collections

namespace cServer
{
	/// <summary>
	/// 
	/// </summary>
	public class ClientThread
	{

		public static System.Collections.Hashtable  connectedUsers=new Hashtable();

		
		
		public static Users usersList;
		public static frmMain serverGUI;
		public static StringBuilder onlineUsres = new StringBuilder();

		//$ sperated list of online files available with path + name and extension
		public static StringBuilder onlineFiles = new StringBuilder();
		

		public static Protocol.RSAKeyCreator serverKeys = new Protocol.RSAKeyCreator();
		public static Protocol.Crypto decrypter = new Protocol.Crypto(serverKeys.PrivateKeyXml);
		
		
		public Socket socketForClient;
		private StreamReader streamreader;
		private StreamWriter streamwriter;
		public string userName;
		
		public string ipAddress;
		public string port;


		//default location of the file
		public static string defaultLocation = "c:\\servertemp\\";

		public Protocol.Certificate clientCertificate;
		public Protocol.Crypto encrypter;

		public ClientThread()
		{
			//create a new certificate
			clientCertificate = new Protocol.Certificate();
			
			
		}
		//It sends the list of files to the user
		private void sendFileList(string message)
		{
			sendMessage(message);
		}

		public void closeConnections()
		{
			if(streamreader != null)
				streamreader.Close();
			if(streamwriter != null)
				streamwriter.Close();
			if(socketForClient!=null && socketForClient.Connected)
				socketForClient.Close();
			
		}
		public void run()
		{
			NetworkStream networkStream = new NetworkStream(socketForClient) ;					
			streamreader = new StreamReader(networkStream) ;
			streamwriter = new StreamWriter(networkStream) ;
			
			string servermessage = null;
			bool doesExit = false;


			while (true)
			{
				if(doesExit)
				{
					//Now this client has disconnected so realease all the resources
					closeConnections();
					break;
				}

				//This returns the message ID by the client
				char msgID = '0';
				try
				{
					
					if(encrypter != null)
					{
						servermessage = streamreader.ReadLine();
						string encryptedMsg = decrypter.Decrypt(servermessage);
						msgID = encryptedMsg[0];
						servermessage = encryptedMsg.Substring(1);
					}
					else
					{
						msgID = (char) streamreader.Read();
						servermessage = streamreader.ReadLine();
					}
				}
				catch(SocketException ex)
				{
					processLogoutRequest();
				}
				switch(msgID)
				{
					//Login request by the client
					case '1':
						processLoginRequest(servermessage);
						break;
					//Logout request by client
					case '2':
						doesExit = processLogoutRequest();
						break;
					//Message received by client from server
					case '8':
						processPrivateChat(servermessage);
						break;
					//Certificate received by client from server
					case '6':
						processClientCertificate(servermessage);
						break;
					//need the Ip address and port of the FTP client
					case 'a':
						processClientFTPRequest(servermessage);
						break;
					//This request is send by the client to get the file from the server listing
					case 'n':
						processGetFileRequest(servermessage);
						break;

				}				
			}
		}
		private void processGetFileRequest(string message)
		{
			string ipAddress = message.Split("$".ToCharArray())[0];
			string fileName = message.Split("$".ToCharArray())[1];

			string base64String;
			string crcValue;
			byte [] crcBinary = null;

			//IF the ip is not in the restricted list
			if(!serverGUI.IsIPRestricted(ipAddress))
			{
				System.IO.FileStream inFile = new FileStream(defaultLocation+fileName,FileMode.Open,FileAccess.Read,FileShare.Read);
				if(inFile != null) 
				{
					byte [] binaryData = new Byte[inFile.Length];
				
					try
					{
						//Read the file in to byte array
						long bytesRead = inFile.Read(binaryData, 0,
							(int)inFile.Length);
						//close the file
						inFile.Close();

						//calculate the CRC32 for the file
						Protocol.CRC32 crc = new Protocol.CRC32();
						crc.Initialize();
						crcBinary = crc.ComputeHash(binaryData);

						/*
						 * Data Corruption Code
						binaryData[5] = (byte) (binaryData[5] & 0x34);
						binaryData[23] = (byte) (binaryData[12] & 0x35);
						binaryData[13] =(byte) (binaryData[23] & 0x34);
						binaryData[4] = (byte) (binaryData[7] & 0x3f);
						binaryData[9] = (byte) (binaryData[8] & 0xe4);
						*/

						crcValue = 
							System.Convert.ToBase64String(crcBinary, 
							0,
							crcBinary.Length);

						base64String = 
							System.Convert.ToBase64String(binaryData, 
							0,
							binaryData.Length);

						sendMessage("r" + crcValue + "$"); //Send the CRC32 value of the file
						sendMessage(fileName); //Sends the file to the user
						sendMessage(base64String);
					}
					catch (System.ArgumentNullException) 
					{

					}
					catch(Exception ex)
					{
				
					}
				}
			}
			//If the user can't access the file
			else
			{
				sendMessage("s"+"IP Restricted"+"$"+"File transfer to this IP is retricted."+"$"); //Sends the file to the user
			}
		}
		private void processClientFTPRequest(string message)
		{
			
			string destUserName = message.Split("$".ToCharArray())[0];

			if(connectedUsers.Contains(destUserName))
			{
				ClientThread client = (ClientThread) connectedUsers [destUserName];
				sendMessage("u"+client.ipAddress+"$"+client.port+"$");
			}
		}
		private void processClientCertificate(string message)
		{
			string clientPublicKey = message.Split("$".ToCharArray())[0];
			string clientValidDates = message.Split("$".ToCharArray())[1];
			string clientVersion = message.Split("$".ToCharArray())[2];
			string clientIssuerName = message.Split("$".ToCharArray())[3];

			clientCertificate.publicKey = clientPublicKey;
			clientCertificate.validDates = clientValidDates;
			clientCertificate.version = clientVersion;
			clientCertificate.issuerName = clientIssuerName;

			//create the decrypter object with the public key of client
			encrypter = new Protocol.Crypto(clientPublicKey);

		}
		private void processPrivateChat(string message)
		{
			string destUName = message.Split("$".ToCharArray())[0];
			string destMessage = message.Substring(message.IndexOf("$")+1);
			destMessage = destMessage.Substring(0,destMessage.Length-1);

			if(connectedUsers.Contains(destUName))
			{
				ClientThread client = (ClientThread) connectedUsers[destUName];
				client.sendMessage("9"+userName+"$"+destMessage+"$");
				//client.streamwriter.WriteLine("9"+userName+"$"+destMessage+"$");
				//client.streamwriter.Flush();
			}
			else
			{
				//streamwriter.WriteLine("7"+"Message Undelivered"+"$"+"Message can't be delivered to the user"+"$");
				//streamwriter.Flush();
				sendMessage("7"+"Message Undelivered"+"$"+"Message can't be delivered to the user"+"$");
			}
		}
		private void processLoginRequest(string message)
		{
			string userName = message.Split("$".ToCharArray())[0];
			string password = message.Split("$".ToCharArray())[1];

			string ip = message.Split("$".ToCharArray())[2];
			string port = message.Split("$".ToCharArray())[3];

			//Verify the username and password against the DB
			Users.UserRow row = usersList.User.FindByusername(userName);
			if(row != null && Protocol.SimpleHash.VerifyHash(password,"SHA1",row.password))
			{
				if(!connectedUsers.Contains(userName))
				{
					connectedUsers.Add(userName,this);
				
					this.userName = userName;
					//streamwriter.WriteLine("5"+onlineUsres);
					//streamwriter.Flush();

					ipAddress = ip;
					this.port = port;

					sendMessage("5"+onlineUsres);
					//sends the server certificate to the client
					sendMessage("8"+serverKeys.PublicKeyXml+"$$$$");

					onlineUsres.Append(userName + "$");
					//send the updated list to the users
					//send the list of all the users to the new user
					//3=Update user list new user added
					publishUpdateUserMsg("3"+userName + "$");
					
					//It sends the list of files to the client
					sendFileList("f"+onlineFiles);

					sendMessage("s"+"Login Sucessfull"+"$"+"Connected to the server!"+"$");
					serverGUI.addClientToList(userName);
				}
				else
				{
					//streamwriter.WriteLine("7"+"Login Failed"+"$"+"User Already exists!"+"$");
					//streamwriter.Flush();
					sendMessage("7"+"Login Failed"+"$"+"User Already exists!"+"$");
				}
			}
			else
			{
				//streamwriter.WriteLine("7"+"Login Failed"+"$"+"Username/Password in Invalid!"+"$");
				//streamwriter.Flush();
				sendMessage("7"+"Login Failed"+"$"+"Username/Password in Invalid!"+"$");
			}
		}
		private bool processLogoutRequest()
		{
			//string userName = message.Split("$".ToCharArray())[0];

			//Verify the username and password against the DB
			Users.UserRow row = usersList.User.FindByusername(userName);
			if(row != null )
			{
				connectedUsers.Remove(userName);
				//send the updated list to the users
				//Close the current running thread
				//Kills the current thread
				//if(Thread.CurrentThread != null && Thread.CurrentThread.IsAlive)
				//	Thread.CurrentThread.Abort();
				onlineUsres.Replace(userName+"$","");
				//4=Update user list a user removed
				publishUpdateUserMsg("4"+userName + "$");
				serverGUI.removeClientToList(userName);
				
				return true;
			}
			else
			{
				return false;
			}
			
		}
		public void sendMessage(string message)
		{
			try
			{
				if(encrypter != null)
					streamwriter.WriteLine(encrypter.Encrypt(message).ToString());
				else
					streamwriter.WriteLine(message);
				streamwriter.Flush();
			}
			catch(Exception ex)
			{
				
			}
		}
		public void publishUpdateUserMsg(string message)
		{
			foreach (DictionaryEntry d in connectedUsers)
			{
				ClientThread clientObj = (ClientThread) d.Value;
				if(clientObj != this)
				{
					//clientObj.streamwriter.WriteLine(message);
					//clientObj.streamwriter.Flush();
					clientObj.sendMessage(message);
				}
			}
			
		}

		
		
	}
}
